=== debian/changelog ===
ocaml (3.07.2a-2ubuntu1) warty; urgency=low

  * Add amd64 support.

 -- LaMont Jones <lamont@mmjgroup.com>  Mon, 12 Jul 2004 20:47:13 +0100

ocaml (3.07.2a-2) unstable; urgency=low

  * Now install the config/Makefile so that nat/bignum can be built as an
    external package.
  * Modified configure so that the Makefile variables for both nat/bignum
    implementations are written in the config/Makefile.

 -- Sven Luther <luther@debian.org>  Wed, 17 Dec 2003 12:52:28 +0100

ocaml (3.07.2a-1) unstable; urgency=low

  * New upstream .2 release, including the ocaml-3.07-pl2 patch.
  * Removed the otherlibs/num library, since the copyright is non-free, and
    the copyright got lost in the HP/Compaq acquisition. Thanks to Bdale
    Garbee for trying to solve this issue, but since the release approaches,
    and upstream is reimplementing the library anyway, i will remove it here.
  * Fixed broken emacs file caml-types.el. (Closes: #218226)

 -- Sven Luther <luther@debian.org>  Fri, 31 Oct 2003 14:46:02 +0100

ocaml (3.07-7) unstable; urgency=high

  * Fixed hppa build problem : hppa needs doubleword aligned doubles.
  * Removed .dpatch extensions for debian/patches/00list, should enable to
    build with older versions of debhelper, like the one in woody.
    (Closes: #214967).
  * Removed leftover ocaml 3.06 ld.conf stuff. (Closes: #214772)
  * Applied the ocaml-3.07-pl2 patch inplace of the previous camlp4 patch.
    (Closes: #216152)

 -- Sven Luther <luther@debian.org>  Fri, 17 Oct 2003 00:48:39 +0200

ocaml (3.07-6) unstable; urgency=low

  * Changed from the -a to the -s option in debhelper functions. Fixed FTBFS
    in all non-native autobuilders.

 -- Sven Luther <luther@debian.org>  Mon,  6 Oct 2003 09:07:42 +0200

ocaml (3.07-5) unstable; urgency=low

  * Somehow the objinfo patch forgot to install objinfo, fixed now. Also
    renamed objinfo to ocamlobjinfo, to be more in line with the other ocaml
    executables.
  * Test for emacsen flavor early one and abort if unsupported.
    (Closes: #213862)

 -- Sven Luther <luther@debian.org>  Fri,  3 Oct 2003 17:08:29 +0200

ocaml (3.07-4) unstable; urgency=low

  * Arg, dh_gencontrol seems to not support putting stuff after the
    substitution variable, which seems somewhat broken to me, anyway, let's
    put the substitution variable last.
  * Forgot to add the camlp4_optional.dpatch to the list of patches to be
    applied. (Closes: #213881)

 -- Sven Luther <luther@debian.org>  Fri,  3 Oct 2003 10:54:26 +0200

ocaml (3.07-3) unstable; urgency=low

  * Fixed BestProvide magic, as a space was breaking non-native builds.

 -- Sven Luther <luther@debian.org>  Fri,  3 Oct 2003 08:16:18 +0200

ocaml (3.07-2) unstable; urgency=low

  * I mistakenly uploaded to experimental, and thus am forced to upload a -2.

 -- Sven Luther <luther@debian.org>  Thu,  2 Oct 2003 11:41:53 +0200

ocaml (3.07-1) experimental; urgency=low

  * New upstream release.
    - Most debian patches where included upstream.
    - Standard library now use .3o suffixes. (Closes: #205391)
  * Dpatchification.
  * Applied the camlp4 optional arguments fix.
  * Fixed emacsen-install so that caml-xemacs and caml-emacs get installed
    only for the corresponding emacs flavors. Thanks go to Jerome Marant.
  * Moved ocaml-source into a tarball.

 -- Sven Luther <luther@debian.org>  Wed,  1 Oct 2003 13:31:23 +0200

ocaml (3.06-21) unstable; urgency=low

  * I botched the debian/rules in the -20 release, fixed it.

 -- Sven Luther <luther@debian.org>  Wed, 20 Aug 2003 13:57:28 +0200

ocaml (3.06-20) unstable; urgency=low

  * Fixed BestProvides substvar stuff. (Closes: #205228, #204537)

 -- Sven Luther <luther@debian.org>  Tue, 19 Aug 2003 18:36:29 +0200

ocaml (3.06-19) unstable; urgency=low

  * Fix a alloc_channel bug. (Closes: #204146).

 -- Sven Luther <luther@debian.org>  Wed,  6 Aug 2003 10:54:38 +0200

ocaml (3.06-18) unstable; urgency=low

  * Dropped camlp4, libcamltk-ocaml and camltk provides as it may confuse apt.

 -- Sven Luther <luther@debian.org>  Fri, 18 Jul 2003 22:29:45 +0200

ocaml (3.06-17) unstable; urgency=low

  * Fixes typo in ocaml_packaging_policy.
  * Moved ocamldoc generated library manpages from section o to 3.
  * Linked to libgdbm-compat, using the new libgdbm-dev package.
    (Closes: #188553)
  * Removed the /etc/magic debconf question, as ocaml is recognized by file
    since version 4.02-1. (Closes: #190037, #189774)
  * Uncommented site specific emacs stuff as suggested by Laurent Bonnaud and
    okeyed by Ralf Treinen. (Closes: #192131)
  * Conflicts with camlidl (<< 1.04), warn if /usr/include/caml is still not
    a symlink, but this should only happen if the user did some hand
    installation.  (Closes: #195574, #192552)

 -- Sven Luther <luther@debian.org>  Sun,  8 Jun 2003 11:52:10 +0200

ocaml (3.06-16) unstable; urgency=low

  * Fix GC memory problem in stat_aux function in stat.c, reported in upstream
    bug #1665 and causes random SEGVs when using Unix.Largefile.stat or
    friends. Thanks to David Brown for providing a patch.  (Closes: #191582)
  * Properly install the latex file ocamldoc.sty. (Closes: #175821)
  * Fixed or overrided most lintian warnings.
  * Fixed configure script to work around the sparc FTBFS with gcc 3.2.
  * Applied Remi's ocaml_packaging_policy changes. (Closes: #177850)
  * Backported the config/auto-aux/async_io.c patch from CVS, to solve the
    graphics module/sleep problem. (Closes: #179199)

 -- Sven Luther <luther@debian.org>  Sat,  3 May 2003 09:45:38 +0200

ocaml (3.06-15) unstable; urgency=low

  * Fixed the /usr/include/caml issue. (Closes: #173720)

 -- Sven Luther <luther@debian.org>  Tue, 24 Dec 2002 10:31:55 +0100

ocaml (3.06-14) unstable; urgency=low

  * Removed the (bad) /usr/lib/ocaml/3.06/ld.conf that comes with the ocaml
    package.
  * Now run ocaml-ldconf in ocaml postinst also. This is needed since
    /usr/lib/ocaml/3.06/ld.conf was in ocaml 3.06-13 and will thus be removed

