=== debian/control ===
Source: ocaml
Section: devel
Priority: optional
Maintainer: Sven Luther <luther@debian.org>
Build-Depends: debhelper (>> 4.0.2), tcl8.4-dev, tk8.4-dev, libncurses5-dev, libgdbm-dev, dpatch, bzip2
Standards-Version: 3.6.0

Package: ocaml
Architecture: any
Depends: ${shlibs:Depends}, libncurses5-dev, ocaml-base (= ${Source-Version}), ocaml-base-3.07
Suggests: xlibs-dev, tcl8.4-dev, tk8.4-dev, ocaml-doc, libgdbm-dev, emacsen
Recommends: ledit, file
Provides: ocaml-3.07 ${F:BestProvides}
Replaces: camlp4
Conflicts: camlp4, camlidl (<< 1.04)
Description: ML language implementation with a class-based object system
 Objective Caml is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 Objective Caml comprises two compilers. One generates bytecode
 which is then interpreted by a C program. This compiler runs quickly,
 generates compact code with moderate memory requirements, and is
 portable to essentially any 32 or 64 bit Unix platform. Performance of
 generated programs is quite good for a bytecoded implementation:
 almost twice as fast as Caml Light 0.7. This compiler can be used
 either as a standalone, batch-oriented compiler that produces
 standalone programs, or as an interactive, toplevel-based system.
 .
 The other compiler generates high-performance native code for a number
 of processors. Compilation takes longer and generates bigger code, but
 the generated programs deliver excellent performance, while retaining
 the moderate memory requirements of the bytecode compiler. It is not
 available on all arches though.

Package: ocaml-base
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: ocaml (<< 3.04-2)
Provides: ocaml-base-3.07
Description: Runtime system for ocaml bytecode executables
 Objective Caml is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains only the runtime system needed to run bytecode
 executables. The `ocaml' package contains the full development suite of
 Objective Caml.

Package: ocaml-native-compilers
Architecture: amd64 arm alpha i386 ia64 powerpc sparc
Depends: ocaml (= ${Source-Version}), ocaml-3.07, ${shlibs:Depends}
Provides: ocaml-best-compilers
Description: Native code compilers of the ocaml suite (the .opt ones)
 Objective Caml is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains the native code version of the compilers and lexer
 (ocamlc.opt, ocamllex.opt, ocamlopt.opt, camlp4o.opt and camlp4r.opt).
 The normal version of these programs are found in the ocaml package.
 For big source codes, these packages can be two to three times faster, but
 for most normal sized sources, the difference won't be noticeable.

Package: ocaml-source
Architecture: all
Provides: ocaml-source-3.07
Description: Sources for Objectif Caml
 Objective Caml is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains the sources needed to build some packages which build
 depend on the ocaml source. Notice that if you want to rebuild ocaml, these
 will not work, consider using the source package instead.
